



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Broken Keyboard（悲剧文本）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Broken Keyboard（悲剧文本）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-19 05:49:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>你有一个键盘，键盘上所有的键都能正常使用，只是Home键和End键有时会自动按下。你并不知道这一情况，而是专心地打稿子，甚至连显示器都没开电源。当你打开显示器之后，展现在你面前的是一段悲剧文本。你的任务是根据给出的键盘上实际输入的内容，计算并输出这段悲剧文本（即显示器上展现的文本）</p>
<p>Input:</p>
<p>一行文本不超过1000000个字符，只包括字母、下划线、字符'['（表示Home键）和字符']'（表示End键盘）。</p>
<p>Output:</p>
<p>一个字符串，即符合题目描述的悲剧文本。</p>
<p>Example:</p>
<p>Input:</p>
<p>This_is_a_[Beijing]_tex</p>
<p>Output:</p>
<p>BeijingThis_is_a__text</p>
<p>___________________________________________________________________________________________________________</p>
<p>问题分析：</p>
<p>该问题最简单的想法是利用数组来保存这些数据，然后用一个变量来保存光标位置，输入一个字符相当于在数组中插入一个字符，但是没插入一个字符将要移动大量的数据，程序的开销会很大。</p>
<p>为了解决这个问题，我们可以利用静态链表解决这个问题</p>
<p>先用一个字符串将每个字符储存起来，s[1-n]，对每个s[i]都会对应一个next[i]游标，储存的是下一个结点的下标，同时利用一个curr，表示光标位置，并用last记录最后元素位置，s[0]是一个虚拟字符，用作头结点。</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
#include&lt;string&gt;<br />
using namespace std;

const int size=100000+1;

int last;       //显示屏上的最后一个字符<br />
int cur;       //光标位置，总在当前s[i]的左方<br />
char s[size];             //用以储存string

int main()<br />
{<br />
	int next[size]={0};           //每个s[i]的游标，初始化为0<br />
	while(scanf("%s",s+1)==1)<br />
	{<br />
		//初始化<br />
		int n=strlen(s+1); //真正的字符从s[1]开始，s[0]是一个虚拟字符<br />
		last=0;<br />
	    cur=0;

		//重排next<br />
		for(int i=1;i&lt;=n;i++)<br />
		{<br />
			if(s[i]=='[')<br />
				cur=0;      //home键<br />
            else if(s[i]==']')<br />
                cur=last;				//end键<br />
     	    else<br />
			{<br />
				next[i]=next[cur];<br />
				next[cur]=i;<br />
			    if(cur==last)last=i;   //当从string的最后插入时，last要+1<br />
				cur=i;<br />
			}<br />
		}

	    //输出<br />
		for(int j=next[0];j!=0;j=next[j])  //依据next中指定的顺序输出<br />
			cout&lt;&lt;s[j];<br />
		cout&lt;&lt;endl;<br />
	}

	return 0;<br />
}
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gexx48.html">thinkphp验证是否登录并跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ez5wq.html">A hard puzzle</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm17019.html">使用supervisor的一些注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz03108.html">cocos2dx 制作单机麻将&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge57ge8.html">sql拼接，String和Stringbuffer的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y6x2n8.html">开源：Sagit&period;Framework For IOS 开发框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp3ozr9.html">转 InnoDB Error Handling</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wj7o0q.html">【转】MySQL sql&lowbar;mode 说明（及处理一起 sql&lowbar;mode 引发的问题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rplnn9.html">ValueError&colon; output parameter for reduction operation logical&lowbar;and has too many dimensions ？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv4ve38.html">&lbrack;C语言&rsqb;进阶&vert;指针与字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jwl45q.html">JS通过键盘点击事件实现div移动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1rjl5q.html">12外观模式Facade</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjg1wr9.html">VirtualBox下扩容vdi文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2lzgj9.html">用MFC库函数AfxBeginThread&lpar;&rpar;来创建线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vp14q.html">&period;NET面试题系列（六）多线程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emypwz9.html">学习 Linux，302（混合环境）&colon; 概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx25xjv8.html">docker 入門</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp7xp49.html">BZOJ1856&colon; &lbrack;Scoi2010&rsqb;字符串&lpar;组合数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p55l3q.html">Windows之Xmanager连接linux打开Oracle视图操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pezrz8.html">&lbrack;实战&rsqb;MVC5&plus;EF6&plus;MySql企业网盘实战&lpar;24&rpar;&mdash;&mdash;视频列表</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gep6k48.html">Redis哈希相关命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jkl4x8.html">基于Debian系统配置Nginx环境的Node&period;js应用教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yp42n8.html">noip2013Day2T3-华容道【一个蒟蒻的详细题解】</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m23348.html">Contest Balloons</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk2v0v8.html">2016 SyScan360 国际前瞻信息安全会议 多角度探讨信息安全</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpj75jq.html">2016年团体程序设计天梯赛-决赛 L1-1&period; 正整数A&plus;B（15）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj16709.html">mysql 数据列按照逗号转成行</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj1gm19.html">【LeetCode】434&period; Number of Segments in a String</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zprzj9.html">html5 article标签举例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ze63x9.html">POJ 3026 Borg Maze（Prim&plus;BFS建邻接矩阵）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
